# openqa-testrepos

Create the contents of the `openqa-testrepo-1` in support of Rocky Linux openQA testing.

## Requirements
The `openqa-testrepo-1` repository contents can be created on Rocky Linux 8 or Rocky Linux 9 host. In both cases the `python3-rpmfluff` package (and dependencies) must be installed.

In Rocky Linux 8 the `python3-rpmfluff` package can be found in the AppStream repository. In Rocky Linux 9 the `python3-rpmfluff` package is provided by EPEL.

### Rocky Linux 8

Installation of `python3-rpmfluff` in Rocky Linux 8 is shown below...

```
$ sudo dnf -y install python3-rpmfluff
Last metadata expiration check: 1:13:23 ago on Fri 29 Dec 2023 06:24:00 PM UTC.
Dependencies resolved.
===============================================================================================================================
 Package                            Architecture            Version                           Repository                  Size
===============================================================================================================================
Installing:
 python3-rpmfluff                   noarch                  0.5.7.1-2.el8                     appstream                   57 k
Installing dependencies:
 createrepo_c                       x86_64                  0.17.7-6.el8                      appstream                   88 k
 createrepo_c-libs                  x86_64                  0.17.7-6.el8                      appstream                  115 k
 drpm                               x86_64                  0.4.1-3.el8                       appstream                   67 k
 elfutils                           x86_64                  0.189-3.el8                       baseos                     552 k
 gc                                 x86_64                  7.6.4-3.el8                       appstream                  108 k
 gdb-headless                       x86_64                  8.2-20.el8.0.1                    appstream                  3.7 M
 guile                              x86_64                  5:2.0.14-7.el8                    appstream                  3.5 M
 libatomic_ops                      x86_64                  7.6.2-3.el8                       appstream                   37 k
 libbabeltrace                      x86_64                  1.5.4-4.el8                       baseos                     199 k
 libipt                             x86_64                  1.6.1-8.el8                       appstream                   49 k
 patch                              x86_64                  2.7.6-11.el8                      baseos                     137 k
 rpm-build                          x86_64                  4.14.3-26.el8                     appstream                  173 k
 zstd                               x86_64                  1.4.4-1.el8                       appstream                  392 k

Transaction Summary
===============================================================================================================================
Install  14 Packages

Total download size: 9.1 M
Installed size: 29 M
Downloading Packages:
(1/14): createrepo_c-0.17.7-6.el8.x86_64.rpm                                                   1.2 MB/s |  88 kB     00:00
...<snip>...

  Verifying        : patch-2.7.6-11.el8.x86_64                                                                           14/14

Installed:
  createrepo_c-0.17.7-6.el8.x86_64      createrepo_c-libs-0.17.7-6.el8.x86_64      drpm-0.4.1-3.el8.x86_64
  elfutils-0.189-3.el8.x86_64           gc-7.6.4-3.el8.x86_64                      gdb-headless-8.2-20.el8.0.1.x86_64
  guile-5:2.0.14-7.el8.x86_64           libatomic_ops-7.6.2-3.el8.x86_64           libbabeltrace-1.5.4-4.el8.x86_64
  libipt-1.6.1-8.el8.x86_64             patch-2.7.6-11.el8.x86_64                  python3-rpmfluff-0.5.7.1-2.el8.noarch
  rpm-build-4.14.3-26.el8.x86_64        zstd-1.4.4-1.el8.x86_64

Complete!
```

### Rocky Linux 9

Installation of `python3-rpmfluff` from EPEL repository in Rocky Linux 9 is shown below...

```
$ sudo dnf -y --enablerepo=epel install python3-rpmfluff
Last metadata expiration check: 0:07:01 ago on Fri 29 Dec 2023 07:31:47 PM UTC.
Dependencies resolved.
===============================================================================================================================
 Package                            Architecture            Version                           Repository                  Size
===============================================================================================================================
Installing:
 python3-rpmfluff                   noarch                  0.6.3-1.el9                       epel                        59 k
Installing dependencies:
 createrepo_c                       x86_64                  0.20.1-2.el9                      appstream                   73 k
 createrepo_c-libs                  x86_64                  0.20.1-2.el9                      appstream                   99 k
 debugedit                          x86_64                  5.0-4.el9                         appstream                   76 k
 ed                                 x86_64                  1.14.2-12.el9                     baseos                      74 k
 elfutils                           x86_64                  0.189-3.el9                       baseos                     526 k
 gdb-minimal                        x86_64                  10.2-11.el9                       appstream                  3.5 M
 info                               x86_64                  6.7-15.el9                        baseos                     224 k
 patch                              x86_64                  2.7.6-16.el9                      appstream                  127 k
 rpm-build                          x86_64                  4.16.1.3-25.el9                   appstream                   59 k
 zstd                               x86_64                  1.5.1-2.el9                       baseos                     546 k

Transaction Summary
===============================================================================================================================
Install  11 Packages

Total download size: 5.3 M
Installed size: 17 M
Downloading Packages:
(1/11): python3-rpmfluff-0.6.3-1.el9.noarch.rpm                                                177 kB/s |  59 kB     00:00

...<snip>...

  Verifying        : gdb-minimal-10.2-11.el9.x86_64                                                                      11/11

Installed:
  createrepo_c-0.20.1-2.el9.x86_64       createrepo_c-libs-0.20.1-2.el9.x86_64       debugedit-5.0-4.el9.x86_64
  ed-1.14.2-12.el9.x86_64                elfutils-0.189-3.el9.x86_64                 gdb-minimal-10.2-11.el9.x86_64
  info-6.7-15.el9.x86_64                 patch-2.7.6-16.el9.x86_64                   python3-rpmfluff-0.6.3-1.el9.noarch
  rpm-build-4.16.1.3-25.el9.x86_64       zstd-1.5.1-2.el9.x86_64

Complete!
```

## Usage

Once the `python3-rpmfluff` (and dependencies) packages are installed, one of the version dependent scripts in this repository can be used to create the contents of the openqa-testrepo-1 repository.

### Rocky Linux 8

```
$ ./tools/testpackages8

$ tree openqa-testrepo-1
openqa-testrepo-1
├── acpica-tools-1-1.noarch.rpm
├── pandoc-common-1-1.noarch.rpm
├── README
└── repodata
    ├── 2b41544bc8ee5e59ebb0893af7464f1aab0f85d58dda9d4976554ec29ebf092a-other.sqlite.bz2
    ├── 30426ccf32448eddf3d19345d0e4c924251a8b6ca9623954e9fb68fdc03b5ea2-other.xml.gz
    ├── 545ace9c9a1bc62b165001e00fd19fb97daeec3facf2ad0fc1b817c4dd8804c2-primary.xml.gz
    ├── bcbd4e18e103de3f88cce2cd5f7248790eeee1bcef100c287e0a6aee7eb03fd1-filelists.sqlite.bz2
    ├── e0675d7d49382249e902ca1937e904e3ab39ea798704e1b7638c047ea017cc25-primary.sqlite.bz2
    ├── edc8d257b7c5e25edef9160935cfafb0fdfb86a32f22b2f9a7bdf266f2aa7647-filelists.xml.gz
    └── repomd.xml

1 directory, 10 files
```


### Rocky Linux 9

```
$ ./tools/testpackages9

$ tree openqa-testrepo-1
openqa-testrepo-1
├── acpica-tools-1-1.noarch.rpm
├── pandoc-common-1-1.noarch.rpm
├── README
└── repodata
    ├── 040b7b4eeb5eb795f50a24d01b9108db0c9d202ef5b593768a03e746545e7930-filelists.xml.gz
    ├── 274e3829951600902693358c55990d9e9c1e0335a38d5b24a49a303d4fcd953a-primary.sqlite.bz2
    ├── 39a14b96bdeb72585a76cc58f613eaaaca3a3075181b302feeb9acf16a26b620-other.sqlite.bz2
    ├── 6bb78cc6422fa5cfd7e0c8bb8d5c32025ae3c1a877895e5819a75aea3b114a03-other.xml.gz
    ├── 8b6c7c9a7f81fdfbe89ce090589207b1842af2681f16d98b599b1ee9b74f63b3-primary.xml.gz
    ├── b271b1890dd76d5dd7644639d848f2527a0787d77ae497d2438680cba18aa990-filelists.sqlite.bz2
    └── repomd.xml

1 directory, 10 files
```
